package com.jamgu.krouter.plugin.utils

class Constants {

    static final String PLUGIN_NAME = "KRouter.Plugin"
    static final String REGISTER_CLASS_NAME = "com/jamgu/krouter/core/RouterMappingInitiator.class"
    static final String REGISTER_CLASS_METHOD_NAME = "init"
    static final String REGISTER_METHOD_NAME = "map"

    class Ext {
        /**
         * default router core version
         */
        static final String DEFAULT_ROUTER_CORE_VERSION = "1.0.3"
        /**
         * default router compiler version
         */
        static final String DEFAULT_ROUTER_COMPILER_VERSION = "1.0.3"
        /**
         * router core version defined by user
         */
        static final String ROUTER_CORE_VERSION = "krouter_core_version"
        /**
         * router compiler version defined by user
         */
        static final String ROUTER_COMPILER_VERSION = "krouter_compiler_version"
        /**
         * conf that decides if plugin log enable
         */
        static final String ROUTER_COMPILE_LOGGABLE = "krouter_compile_loggable"
        /**
         * conf that decides is auto add dependency
         */
        static final String ROUTER_AUTO_ADD_DEPENDENCY = "krouter_auto_add_dependency"

        static final String ROUTER_EXTRA_SUPPORT_MODULES = "krouter_extra_support_modules"
    }

    class Opt {
        /**
         * postfix of name of classes generated by apt,
         * for classifying different generated classes from different  module
         */
        static final String MODULE_NAME = "KRouter_Module_Name"
        static final String LOGGABLE = "KRouter_Compile_Loggable"
    }

    class Apt {
        /**
         * package name of class, which generated by apt
         */
        static final String GENERATED_CLASS_PACKAGE_NAME = "com/jamgu/krouter/"
        /**
         * package name of interface, which will be implemented by all the generated classes
         */
        static final String ROUTER_INTERFACE_PACKAGE_NAME = 'com/jamgu/krouter/core/'
        /**
         * interface name, see: {@link #ROUTER_INTERFACE_PACKAGE_NAME}
         */
        static final String ROUTER_INTERFACE_NAME = "IKRouterMapping"
    }

}
